import { getScrollNode } from "get-scroll-info";
import callfunc from "call-func";
import { easeInOutCubic, aniTimer } from "easing-lib";
import { NEW_OBJ } from "reshow-constant";
var isRunning = NEW_OBJ();
/**
 *  !!Important!! any logic change need take care isRunning
 */

var smoothScrollTo = function smoothScrollTo(to, duration, el, callback, scrollKey) {
  scrollKey = scrollKey || "scrollTop";
  var scrollNode = getScrollNode(el);

  var cb = function cb() {
    if (isRunning[scrollKey]) {
      cancel();
      callfunc(callback, [{
        scrollNode: scrollNode,
        from: from,
        to: to,
        go: go
      }]);
    }
  };

  var cancel = function cancel() {
    clearTimeout(isRunning[scrollKey]);
    isRunning[scrollKey] = false;
  };

  if (isRunning[scrollKey]) {
    clearTimeout(isRunning[scrollKey]);
    isRunning[scrollKey] = setTimeout(function () {
      scrollNode[scrollKey] = to;
      cb();
    });
    return cancel;
  }

  if (null == duration) {
    duration = 500;
  }

  var from = scrollNode[scrollKey];
  var go = to - from;

  if (!go) {
    return function () {};
  }

  aniTimer({
    isContinue: function isContinue(elapsedTime) {
      if (isRunning[scrollKey]) {
        var progress = easeInOutCubic(elapsedTime, from, go, duration);
        scrollNode[scrollKey] = progress;
        return true;
      }
    },
    cancel: function cancel() {
      return cb();
    },
    done: function done() {
      return cb();
    }
  }, duration);
  isRunning[scrollKey] = true;
  return cancel;
};

export default smoothScrollTo;